
class cell (c : int) =
  object
  val state = c
  method get_state = state
end

class virtual cellular_automata width height =
  let init_state = Array.make_matrix width height (new cell 0) in
  object (self)
  val mutable state = init_state

  val virtual states : int
  method virtual f : int -> int -> <get_state : int>

  method get_width = width
  method get_height = height
  method get_states = states
  method get_cell x y = state.(x).(y)
  method set_cell x y c = state.(x).(y) <- c

  method private pw x = if x<0 then width-1 else if x=width then 0 else x
  method private ph y = if y<0 then height-1 else if y=height then 0 else y

  method private update_state up_function =
    let new_state = Array.make_matrix width height (new cell 0) in
    for i=0 to width-1 do
      for j=0 to height-1 do
         new_state.(i).(j) <- up_function i j
      done
    done ;
    state <- new_state

  method random_configuration = self#update_state (fun i j->new cell (Random.int states))
  method step = self#update_state (self#f)
  method reset = state <- init_state

  initializer Random.self_init ()
end