open Ca

class wire width height =
  object
  inherit cellular_automata width height as p
  val states = 4

  method f x y = let c = (state.(x).(y))#get_state in
    match c with
    | 0 -> new cell 0
    | 1 -> new cell 2
    | 2 -> new cell 3
    | 3 -> let nhead = ref 0 in
      for i=(-1) to 1 do
        for j=(-1) to 1 do
          if not (i=0 && j=0) && (state.(p#pw (x+i)).(p#ph (y+j)))#get_state = 1 then incr nhead
        done
      done ;
      if !nhead=1 or !nhead=2 then new cell 1 else new cell 3
    | _ -> failwith "Bad state"
end